From 4788d7a0a2a6b4b5291aff888726a25d0800710e Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 15:57:10 +0000
Subject: [PATCH 144/254] Add a subscriptions widget.


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index 9646f8e..80f4520 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -48,7 +48,13 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='badges', index=4,
+        plugin='subscriptions', index=4,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='badges', index=5,
         _config=json.dumps({
             'username': username,
         }))
diff --git a/hubs/models.py b/hubs/models.py
index 8c7a51a..eed4163 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -252,10 +252,28 @@ class User(BASE):
         }
 
     @property
+    def ownerships(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'owner']
+    @property
+    def memberships(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'member' or assoc.role =='owner']
+
+    @property
+    def subscriptions(self):
+        return [assoc.hub for assoc in self.associations
+                if assoc.role == 'subscriber']
+
+    @property
     def username(self):
         return self.openid.split('.')[0]
 
     @classmethod
+    def by_username(cls, session, username):
+        return cls.by_openid(session, "%s.id.fedoraproject.org" % username)
+
+    @classmethod
     def by_openid(cls, session, openid):
         return session.query(cls).filter_by(openid=openid).first()
 
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 5f4d01b..b644707 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -8,6 +8,7 @@ from hubs.widgets import badges
 from hubs.widgets import fedmsgs
 from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
+from hubs.widgets import subscriptions
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -25,6 +26,7 @@ registry = {
     'fedmsgs': fedmsgs,
     'fedmsgstats': fedmsgstats,
     'feed': feed,
+    'subscriptions': subscriptions,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
new file mode 100644
index 0000000..f37819f
--- /dev/null
+++ b/hubs/widgets/subscriptions.py
@@ -0,0 +1,48 @@
+#from hubs.hinting import hint, prefixed as _
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+
+from hubs import validators
+
+import hubs.models
+
+from fedmsg.meta.base import BaseConglomerator as BC
+
+import jinja2
+
+chrome = panel('Hubs', key='associations')
+template = jinja2.Template("""
+{% if associations %}
+    {% if memberships %}
+        <p>Belongs to: {{memberships_text}}</p>
+    {% endif %}
+    <hr/>
+    {% if subscriptions %}
+        <p>Subscribes to: {{subscriptions_text}}</p>
+    {% endif %}
+{% endif %}
+""")
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    user = hubs.models.User.by_username(session, username)
+    ownerships = [u.name for u in user.ownerships]
+    memberships = [u.name for u in user.memberships]
+    subscriptions = [u.name for u in user.subscriptions]
+    return dict(
+        associations=memberships + ownerships,
+        ownerships=ownerships,
+        memberships=memberships,
+        subscriptions=subscriptions,
+        ownerships_text=BC.list_to_series(ownerships),
+        memberships_text=BC.list_to_series(memberships),
+        subscriptions_text=BC.list_to_series(subscriptions),
+    )
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError()

